import {
  Annotation,
  Decorator,
} from '@overflow/commons/core/reflect';

import {
  PropertyKeyType,
  TypeUtil,
} from '@overflow/commons/core/type';

export interface PreDestroyAnnotationAttributes {
}

export class PreDestroyAnnotation extends Annotation {
  public readonly attributes: PreDestroyAnnotationAttributes = {

  };

  public constructor() {
    super();
  }

  public methodDecorator<T>(target: Object, propertyKey: PropertyKeyType,
                            descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void {
    console.log('PreDestroy');
  }

}

export const PreDestroy = Decorator.create(PreDestroyAnnotation);
